# Element Summary

Element | Description | Class
--- | --- | ---
component | a JBI component for hosting endpoints that can use either SOAP/HTTP or SOAP/JMS. | org.apache.servicemix.cxfbc.CxfBcComponent
consumer | a consumer endpoint that is capable of using SOAP/HTTP or SOAP/JMS | org.apache.servicemix.cxfbc.CxfBcConsumer
provider | a provider endpoint that is capable of exposing SOAP/HTTP or SOAP/JMS services | org.apache.servicemix.cxfbc.CxfBcProvider

# Element Detail

## Element: component

Attribute | Type | Description
--- | --- | ---
busConfig | xs:string | the location of the CXF configuration file used to configure the CXF bus for all endpoints in the container. Endpoint-specific configuration overrides these settings. This allows you to configure features like WS-RM and JMS runtime behavior.

Element | Type | Description
--- | --- | ---
authenticationService | <spring:bean/> | the authentication service object used by a component
configuration | <spring:bean/> |
endpoints | (<spring:bean/>)* | the list of endpoints hosted by the component
executorFactory | <spring:bean/> | The executor factory to use to create the executor. If none is provided, one will be retrieved from the JBI container when the component is deployed into ServiceMix 3.x, or a default implementation will be used.

## Element: consumer

Attribute | Type | Description
--- | --- | ---
busCfg | xs:string | the location of the CXF configuration file used to configure the CXF bus. This allows you to configure features like WS-RM and JMS runtime behavior.
delegateToJaas | xs:boolean | Specifies if the endpoint delegate to JAASAuthenticationService to do the authentication.
endpoint | xs:string | Get the endpoint implementation.
interfaceName | xs:QName | Get the qualified name of the endpoint interface.
jaasDomain | xs:string | jaasDomain of this cxfbc consumer endpoint
locationURI | xs:string | the HTTP address to which requests are sent. This value will overide any value specified in the WSDL.
mtomEnabled | xs:boolean | Specifies if MTOM / attachment support is enabled. Default is `false`.
schemaValidationEnabled | xs:boolean | Specifies if the endpoint use schemavalidation for the incoming/outgoing message.
service | xs:QName | Get the service qualified name of the endpoint.
synchronous | xs:boolean | Specifies if the endpoint expects send messageExchange by sendSync .
targetEndpoint | xs:string | the name of the endpoint to which requests are sent
targetInterface | xs:QName | the QName of the interface to which requests are sent
targetOperation | xs:QName | the QName of the operation to which requests are sent
targetService | xs:QName | the QName of the service to which requests are sent
targetUri | xs:string | Gets the target URI of the consumer endpoint.
timeout | xs:long | the number of second the endpoint will wait for a response. The default is unlimited.
useJBIWrapper | xs:boolean | Specifies if the JBI wrapper is sent in the body of the message. Default is `true`.
useSOAPEnvelope | xs:boolean | Specifies if the endpoint expects soap messages when useJBIWrapper is false,
x509 | xs:boolean | Specifies if the endpoint use X.509 Certificate to do the authentication.

Element | Type | Description
--- | --- | ---
features | (<spring:bean/>)* | Specifies the cxf features set for this endpoint
inFaultInterceptors | (<spring:bean/>)* | a list of beans configuring interceptors that process incoming faults
inInterceptors | (<spring:bean/>)* | a list of beans configuring interceptors that process incoming responses
outFaultInterceptors | (<spring:bean/>)* | a list of beans configuring interceptors that process fault messages being returned to the consumer
outInterceptors | (<spring:bean/>)* | a list of beans configuring interceptors that process requests
properties | <spring:bean/> | Sets arbitrary properties that are added to the CXF context at the Endpoint level
providedBus | <spring:bean/> | a preconfigured CXF Bus object to use; overrides busCfg
wsdl | <spring:bean/> | the location of the WSDL document defining the endpoint's interface

## Element: provider

Attribute | Type | Description
--- | --- | ---
busCfg | xs:string | the location of the CXF configuration file used to configure the CXF bus. This allows you to configure features like WS-RM and JMS runtime behavior.
endpoint | xs:string | Get the endpoint implementation.
interfaceName | xs:QName | Get the qualified name of the endpoint interface.
locationURI | xs:string | the HTTP address of the exposed service. This value will overide any value specified in the WSDL.
mtomEnabled | xs:boolean | Specifies if MTOM / attachment support is enabled. Default is `false`.
schemaValidationEnabled | xs:boolean | Specifies if the endpoint use schemavalidation for the incoming/outgoing message.
service | xs:QName | Get the service qualified name of the endpoint.
synchronous | xs:boolean | Specifies if the endpoints send message synchronously to external server using underlying
useJBIWrapper | xs:boolean | Specifies if the JBI wrapper is sent in the body of the message. Default is `true`.
useSOAPEnvelope | xs:boolean | Specifies if the endpoint expects soap messages when useJBIWrapper is false,

Element | Type | Description
--- | --- | ---
features | (<spring:bean/>)* | Specifies the cxf features set for this endpoint
inFaultInterceptors | (<spring:bean/>)* | a list of beans configuring interceptors that process incoming faults
inInterceptors | (<spring:bean/>)* | a list of beans configuring interceptors that process incoming requests
outFaultInterceptors | (<spring:bean/>)* | a list of beans configuring interceptors that process fault messages being returned to the consumer
outInterceptors | (<spring:bean/>)* | a list of beans configuring interceptors that process responses
properties | <spring:bean/> | Sets arbitrary properties that are added to the CXF context at the Endpoint level
providedBus | <spring:bean/> | a preconfigured CXF Bus object to use; overrides busCfg
wsdl | <spring:bean/> | the location of the WSDL document defining the endpoint's interface